/*
	this file is under GPL
*/

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#define KMELEON_PLUGIN_EXPORTS
#include <kmeleon_plugin.h>

#define PLUGIN_NAME "Timer Plugin"

long DoMessage(const char *, const char *, const char *, long, long);
void TimerProcMain(int);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void Create(HWND hWndParent);

WNDPROC KMeleonWndProc;

kmeleonPlugin kPlugin = {
	KMEL_PLUGIN_VER,
	PLUGIN_NAME,
	DoMessage
};

HWND g_curHwnd;

#define PROCTMPL(n) VOID CALLBACK TimerProc ## n \
	(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime) \
	{ TimerProcMain(n); }

#define TIMERNUM 10

PROCTMPL(0) PROCTMPL(1) PROCTMPL(2) PROCTMPL(3) PROCTMPL(4)
PROCTMPL(5) PROCTMPL(6) PROCTMPL(7) PROCTMPL(8) PROCTMPL(9)

TIMERPROC g_timerproc[TIMERNUM] = {
	TimerProc0, TimerProc1, TimerProc2, TimerProc3, TimerProc4,
	TimerProc5, TimerProc6, TimerProc7, TimerProc8, TimerProc9,
};

struct {
	int timerId;
	int cmdId;
	int interval;
} g_timerset[TIMERNUM];


void TimerProcMain(int id)
{
	if (IsWindow(g_curHwnd)) {
		PostMessage(g_curHwnd, WM_COMMAND, g_timerset[id].cmdId, 0);
	}
}


BOOL deletetimer(int id)
{
	if (KillTimer(NULL, g_timerset[id].timerId)) {
		g_timerset[id].timerId = 0;
		g_timerset[id].cmdId = 0;
		g_timerset[id].interval = 0;
		return TRUE;
	}
	return FALSE;
}

void settimer(char *interval, char *cmd)
{
	int cmdId, ninterval, i;
	
	cmdId = kPlugin.kFuncs->GetID(cmd);
	ninterval = atoi(interval) * 1000;
	if (ninterval <= 0 || cmdId <= 0) return;
	for (i = 0; i < TIMERNUM; i ++) {
		if (g_timerset[i].timerId != 0 && g_timerset[i].cmdId == cmdId) {
			if (g_timerset[i].interval == ninterval || ! deletetimer(i)) {
				return;
			}
			break;
		}
	}
	for (i = 0; i < TIMERNUM; i ++) {
		if (g_timerset[i].timerId == 0) {
			g_timerset[i].timerId = SetTimer(NULL, 0, ninterval, g_timerproc[i]);
			g_timerset[i].cmdId = cmdId;
			g_timerset[i].interval = ninterval;
			return;
		}
	}
}


void killtimer(char *cmd)
{
	int cmdId, i;
	
	cmdId = kPlugin.kFuncs->GetID(cmd);
	if (cmdId <= 0) return;
	for (i = 0; i < TIMERNUM; i ++) {
		if (g_timerset[i].timerId != 0 && g_timerset[i].cmdId == cmdId) {
			deletetimer(i);
		}
	}
}


void cleartimer()
{
	int i;
	
	for (i = 0; i < TIMERNUM; i ++) {
		if (g_timerset[i].timerId != 0) {
			deletetimer(i);
		}
	}
}


long DoMessage(const char *to, const char *from, const char *subject,
               long data1, long data2)
{
	if (to[0] == '*' || stricmp(to, kPlugin.dllname) == 0) {
		if (stricmp(subject, "Create") == 0) {
			Create((HWND) data1);
		} else if (stricmp(subject, "SetTimer") == 0) {
			settimer((char *) data1, (char *) data2);
		} else if (stricmp(subject, "KillTimer") == 0) {
			killtimer((char *) data1);
		} else if (stricmp(subject, "ClearTimer") == 0 ||
				   stricmp(subject, "Quit") == 0) {
			cleartimer();
		} else return 0;
		return 1;
	}
	return 0;
}


void Create(HWND hWndParent)
{
	KMeleonWndProc = (WNDPROC) GetWindowLong(hWndParent, GWL_WNDPROC);
	SetWindowLong(hWndParent, GWL_WNDPROC, (LONG)WndProc);
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
	WPARAM wParam, LPARAM lParam)
{
	int fActive = LOWORD(wParam);
	
	switch (message) {
	case WM_ACTIVATE:
		if (fActive == WA_ACTIVE || fActive == WA_CLICKACTIVE) {
			g_curHwnd = hWnd;
		}
		break;
	}
	return CallWindowProc(KMeleonWndProc, hWnd, message, wParam, lParam);
}


extern "C" {
	BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
	{
		switch (dwReason) {
		case DLL_PROCESS_DETACH:
			cleartimer();
			break;
		}
		return TRUE;
	}
	
	KMELEON_PLUGIN kmeleonPlugin *GetKmeleonPlugin() {
		return &kPlugin;
	}
	
	KMELEON_PLUGIN int DrawBitmap(DRAWITEMSTRUCT *dis) {
		return 14; // 14 = icon width
	}
}
